#include "game.h"
#include <avr/io.h>

void init_table(int *table, int size)
{
	int i;
	
	for (i = 0; i < size; i++) {
		table[i] = -1;
	}
}

void reset_table(int *table, int size)
{
	int i;
	
	for (i = 0; i < size; i++) {
		table[i] = -1;
	}
	
	DDRA = 0;
	DDRB = 0;
	DDRC = 0;
	
	PORTA = 0;
	PORTB = 0;
	PORTC = 0;
}

void add_element(int *table, int type, int poz)
{
	if (table[poz] == -1) {
		table[poz] = type;
	}
}

int check_win(int *table, int size)
{
	int i;
	
	for (i = 0; i < 3; i++) {
		// check row
		if (table[i * 3] != -1 && table[i * 3] == table[i * 3 + 1] &&
				table[i * 3] == table[i * 3 + 2]) {
			return table[i * 3];
		}
		
		// check column
		if (table[i] != -1 && table[i] == table[i + 3] &&
				table[i] == table[i + 6]) {
			return table[i];
		}
	}
	
	// check diagonals
	if ((table[0] != -1 && table[0] == table[4] && table[0] == table[8]) ||
		(table[2] != -1 && table[2] == table[4] && table[2] == table[6])) {
		return table[4];
	}
	
	// check draw
	for (i = 0; i < size; i++) {
		if (table[i] == -1) {
			// still playing
			return -1;
		}
	}
	
	// draw
	return -2;
}