#include <avr/io.h>
#include <util/delay.h>
#include "usart.h"
#include "game.h"
#include <stdio.h>

#define CMD_SIZE 3

int main(void)
{
	char c;
	int table[9];
	
	
	
	USART0_init(); /* bluetooth module */ 
	init_table(table, 9); /* init table */
	

	while (1) {
		//USART0_sreceive(command, CMD_SIZE);
		c = USART0_receive();
		
		if (c == '0') {
			
			add_element(table, X, 0);
			DDRA |= (1 << PA0);
			PORTA |= (1 << PA0);
		}
		if (c == 'a') {
			add_element(table, O, 0);
			DDRA |= (1 << PA1);
			PORTA |= (1 << PA1);
		}
		if (c == '1') {
			add_element(table, X, 1);
			DDRA |= (1 << PA2);
			PORTA |= (1 << PA2);
		}
		if (c == 'b') {
			add_element(table, O, 1);
			DDRA |= (1 << PA3);
			PORTA |= (1 << PA3);
		}
		if (c == '2') {
			add_element(table, X, 2);
			DDRA |= (1 << PA4);
			PORTA |= (1 << PA4);
		}
		if (c == 'c') {
			add_element(table, O, 2);
			DDRA |= (1 << PA5);
			PORTA |= (1 << PA5);
		}
		if (c == '3') {
			add_element(table, X, 3);
			DDRA |= (1 << PA6);
			PORTA |= (1 << PA6);
		}
		if (c == 'd') {
			add_element(table, O, 3);
			DDRA |= (1 << PA7);
			PORTA |= (1 << PA7);
		}
		if (c == '4') {
			add_element(table, X, 4);
			DDRC |= (1 << PC0);
			PORTC |= (1 << PC0);
		}
		if (c == 'e') {
			add_element(table, O, 4);
			DDRC |= (1 << PC1);
			PORTC |= (1 << PC1);
		}
		if (c == '5') {
			add_element(table, X, 5);
			DDRC |= (1 << PC2);
			PORTC |= (1 << PC2);
		}
		if (c == 'f') {
			add_element(table, O, 5);
			DDRC |= (1 << PC3);
			PORTC |= (1 << PC3);
		}
		if (c == '6') {
			add_element(table, X, 6);
			DDRC |= (1 << PC4);
			PORTC |= (1 << PC4);
		}
		if (c == 'g') {
			add_element(table, O, 6);
			DDRC |= (1 << PC5);
			PORTC |= (1 << PC5);
		}
		if (c == '7') {
			add_element(table, X, 7);
			DDRC |= (1 << PC6);
			PORTC |= (1 << PC6);		}
		if (c == 'h') {
			add_element(table, O, 7);
			DDRB |= (1 << PB2);
			PORTB |= (1 << PB2);
		}
		if (c == '8') {
			add_element(table, X, 8);
			DDRB |= (1 << PB0);
			PORTB |= (1 << PB0);
		}
		if (c == 'i') {
			add_element(table, O, 8);
			DDRB |= (1 << PB1);
			PORTB |= (1 << PB1);
		}
		
		if (check_win(table, 9) != -1) {
			DDRD |= (1 << PD7);
			PORTD |= (1 << PD7);
			_delay_ms(2000);
			reset_table(table, 9);
		}
	}
	
	return 0;
}
	